var jsutils_invariant = require("../jsutils/invariant.js");

const LineRegExp = /\r\n|[\n\r]/g;

exports.getLocation = function getLocation(source, position) {
  let lastLineStart = 0;
  let line = 1;
  for (const match of source.body.matchAll(LineRegExp)) {
    "number" == typeof match.index || jsutils_invariant.invariant(!1);
    if (match.index >= position) {
      break;
    }
    lastLineStart = match.index + match[0].length;
    line += 1;
  }
  return {
    line,
    column: position + 1 - lastLineStart
  };
};
