import { invariant } from "../jsutils/invariant.mjs";

const LineRegExp = /\r\n|[\n\r]/g;

function getLocation(source, position) {
  let lastLineStart = 0;
  let line = 1;
  for (const match of source.body.matchAll(LineRegExp)) {
    "number" == typeof match.index || invariant(!1);
    if (match.index >= position) {
      break;
    }
    lastLineStart = match.index + match[0].length;
    line += 1;
  }
  return {
    line,
    column: position + 1 - lastLineStart
  };
}

export { getLocation };
