var graphql_web = require("@0no-co/graphql.web");

function isExecutableDefinitionNode(node) {
  return node.kind === graphql_web.Kind.OPERATION_DEFINITION || node.kind === graphql_web.Kind.FRAGMENT_DEFINITION;
}

function isTypeSystemDefinitionNode(node) {
  return node.kind === graphql_web.Kind.SCHEMA_DEFINITION || isTypeDefinitionNode(node) || node.kind === graphql_web.Kind.DIRECTIVE_DEFINITION;
}

function isTypeDefinitionNode(node) {
  return node.kind === graphql_web.Kind.SCALAR_TYPE_DEFINITION || node.kind === graphql_web.Kind.OBJECT_TYPE_DEFINITION || node.kind === graphql_web.Kind.INTERFACE_TYPE_DEFINITION || node.kind === graphql_web.Kind.UNION_TYPE_DEFINITION || node.kind === graphql_web.Kind.ENUM_TYPE_DEFINITION || node.kind === graphql_web.Kind.INPUT_OBJECT_TYPE_DEFINITION;
}

function isTypeSystemExtensionNode(node) {
  return node.kind === graphql_web.Kind.SCHEMA_EXTENSION || isTypeExtensionNode(node);
}

function isTypeExtensionNode(node) {
  return node.kind === graphql_web.Kind.SCALAR_TYPE_EXTENSION || node.kind === graphql_web.Kind.OBJECT_TYPE_EXTENSION || node.kind === graphql_web.Kind.INTERFACE_TYPE_EXTENSION || node.kind === graphql_web.Kind.UNION_TYPE_EXTENSION || node.kind === graphql_web.Kind.ENUM_TYPE_EXTENSION || node.kind === graphql_web.Kind.INPUT_OBJECT_TYPE_EXTENSION;
}

exports.isDefinitionNode = function isDefinitionNode(node) {
  return isExecutableDefinitionNode(node) || isTypeSystemDefinitionNode(node) || isTypeSystemExtensionNode(node);
};

exports.isExecutableDefinitionNode = isExecutableDefinitionNode;

exports.isSelectionNode = function isSelectionNode(node) {
  return node.kind === graphql_web.Kind.FIELD || node.kind === graphql_web.Kind.FRAGMENT_SPREAD || node.kind === graphql_web.Kind.INLINE_FRAGMENT;
};

exports.isTypeDefinitionNode = isTypeDefinitionNode;

exports.isTypeExtensionNode = isTypeExtensionNode;

exports.isTypeNode = function isTypeNode(node) {
  return node.kind === graphql_web.Kind.NAMED_TYPE || node.kind === graphql_web.Kind.LIST_TYPE || node.kind === graphql_web.Kind.NON_NULL_TYPE;
};

exports.isTypeSystemDefinitionNode = isTypeSystemDefinitionNode;

exports.isTypeSystemExtensionNode = isTypeSystemExtensionNode;

exports.isValueNode = function isValueNode(node) {
  return node.kind === graphql_web.Kind.VARIABLE || node.kind === graphql_web.Kind.INT || node.kind === graphql_web.Kind.FLOAT || node.kind === graphql_web.Kind.STRING || node.kind === graphql_web.Kind.BOOLEAN || node.kind === graphql_web.Kind.NULL || node.kind === graphql_web.Kind.ENUM || node.kind === graphql_web.Kind.LIST || node.kind === graphql_web.Kind.OBJECT;
};
