import { assertName } from "../type/assertName.mjs";

import { GraphQLError } from "@0no-co/graphql.web";

function assertValidName(name) {
  const error = isValidNameError(name);
  if (error) {
    throw error;
  }
  return name;
}

function isValidNameError(name) {
  if (name.startsWith("__")) {
    return new GraphQLError(`Name "${name}" must not begin with "__", which is reserved by GraphQL introspection.`);
  }
  try {
    assertName(name);
  } catch (error) {
    return error;
  }
}

export { assertValidName, isValidNameError };
