var graphql_web = require("@0no-co/graphql.web");

exports.getOperationRootType = function getOperationRootType(schema, operation) {
  if ("query" === operation.operation) {
    const queryType = schema.getQueryType();
    if (!queryType) {
      throw new graphql_web.GraphQLError("Schema does not define the required query root type.", {
        nodes: operation
      });
    }
    return queryType;
  }
  if ("mutation" === operation.operation) {
    const mutationType = schema.getMutationType();
    if (!mutationType) {
      throw new graphql_web.GraphQLError("Schema is not configured for mutations.", {
        nodes: operation
      });
    }
    return mutationType;
  }
  if ("subscription" === operation.operation) {
    const subscriptionType = schema.getSubscriptionType();
    if (!subscriptionType) {
      throw new graphql_web.GraphQLError("Schema is not configured for subscriptions.", {
        nodes: operation
      });
    }
    return subscriptionType;
  }
  throw new graphql_web.GraphQLError("Can only have query, mutation and subscription operations.", {
    nodes: operation
  });
};
