var jsutils_naturalCompare = require("../jsutils/naturalCompare.js");

var graphql_web = require("@0no-co/graphql.web");

function sortValueNode(valueNode) {
  switch (valueNode.kind) {
   case graphql_web.Kind.OBJECT:
    return {
      ...valueNode,
      fields: (fields = valueNode.fields, fields.map((fieldNode => ({
        ...fieldNode,
        value: sortValueNode(fieldNode.value)
      }))).sort(((fieldA, fieldB) => jsutils_naturalCompare.naturalCompare(fieldA.name.value, fieldB.name.value))))
    };

   case graphql_web.Kind.LIST:
    return {
      ...valueNode,
      values: valueNode.values.map(sortValueNode)
    };

   case graphql_web.Kind.INT:
   case graphql_web.Kind.FLOAT:
   case graphql_web.Kind.STRING:
   case graphql_web.Kind.BOOLEAN:
   case graphql_web.Kind.NULL:
   case graphql_web.Kind.ENUM:
   case graphql_web.Kind.VARIABLE:
    return valueNode;
  }
  var fields;
}

exports.sortValueNode = sortValueNode;
