import { naturalCompare } from "../jsutils/naturalCompare.mjs";

import { Kind } from "@0no-co/graphql.web";

function sortValueNode(valueNode) {
  switch (valueNode.kind) {
   case Kind.OBJECT:
    return {
      ...valueNode,
      fields: (fields = valueNode.fields, fields.map((fieldNode => ({
        ...fieldNode,
        value: sortValueNode(fieldNode.value)
      }))).sort(((fieldA, fieldB) => naturalCompare(fieldA.name.value, fieldB.name.value))))
    };

   case Kind.LIST:
    return {
      ...valueNode,
      values: valueNode.values.map(sortValueNode)
    };

   case Kind.INT:
   case Kind.FLOAT:
   case Kind.STRING:
   case Kind.BOOLEAN:
   case Kind.NULL:
   case Kind.ENUM:
   case Kind.VARIABLE:
    return valueNode;
  }
  var fields;
}

export { sortValueNode };
