var language_lexer = require("../language/lexer.js");

var language_source = require("../language/source.js");

var language_tokenKind = require("../language/tokenKind.js");

var graphql_web = require("@0no-co/graphql.web");

exports.stripIgnoredCharacters = function stripIgnoredCharacters(source) {
  const sourceObj = language_source.isSource(source) ? source : new language_source.Source(source);
  const body = sourceObj.body;
  const lexer = new language_lexer.Lexer(sourceObj);
  let strippedBody = "";
  let wasLastAddedTokenNonPunctuator = !1;
  while (lexer.advance().kind !== language_tokenKind.TokenKind.EOF) {
    const currentToken = lexer.token;
    const tokenKind = currentToken.kind;
    const isNonPunctuator = !language_lexer.isPunctuatorTokenKind(currentToken.kind);
    if (wasLastAddedTokenNonPunctuator) {
      if (isNonPunctuator || currentToken.kind === language_tokenKind.TokenKind.SPREAD) {
        strippedBody += " ";
      }
    }
    const tokenBody = body.slice(currentToken.start, currentToken.end);
    if (tokenKind === language_tokenKind.TokenKind.BLOCK_STRING) {
      strippedBody += graphql_web.printBlockString(currentToken.value, {
        minimize: !0
      });
    } else {
      strippedBody += tokenBody;
    }
    wasLastAddedTokenNonPunctuator = isNonPunctuator;
  }
  return strippedBody;
};
