var type_definition = require("../type/definition.js");

var graphql_web = require("@0no-co/graphql.web");

exports.typeFromAST = function typeFromAST(schema, typeNode) {
  switch (typeNode.kind) {
   case graphql_web.Kind.LIST_TYPE:
    {
      const innerType = typeFromAST(schema, typeNode.type);
      return innerType && new type_definition.GraphQLList(innerType);
    }

   case graphql_web.Kind.NON_NULL_TYPE:
    {
      const innerType = typeFromAST(schema, typeNode.type);
      return innerType && new type_definition.GraphQLNonNull(innerType);
    }

   case graphql_web.Kind.NAMED_TYPE:
    return schema.getType(typeNode.name.value);
  }
};
