import { GraphQLNonNull, GraphQLList } from "../type/definition.mjs";

import { Kind } from "@0no-co/graphql.web";

function typeFromAST(schema, typeNode) {
  switch (typeNode.kind) {
   case Kind.LIST_TYPE:
    {
      const innerType = typeFromAST(schema, typeNode.type);
      return innerType && new GraphQLList(innerType);
    }

   case Kind.NON_NULL_TYPE:
    {
      const innerType = typeFromAST(schema, typeNode.type);
      return innerType && new GraphQLNonNull(innerType);
    }

   case Kind.NAMED_TYPE:
    return schema.getType(typeNode.name.value);
  }
}

export { typeFromAST };
