var jsutils_keyValMap = require("../jsutils/keyValMap.js");

var graphql_web = require("@0no-co/graphql.web");

exports.valueFromASTUntyped = function valueFromASTUntyped(valueNode, variables) {
  switch (valueNode.kind) {
   case graphql_web.Kind.NULL:
    return null;

   case graphql_web.Kind.INT:
    return parseInt(valueNode.value, 10);

   case graphql_web.Kind.FLOAT:
    return parseFloat(valueNode.value);

   case graphql_web.Kind.STRING:
   case graphql_web.Kind.ENUM:
   case graphql_web.Kind.BOOLEAN:
    return valueNode.value;

   case graphql_web.Kind.LIST:
    return valueNode.values.map((node => valueFromASTUntyped(node, variables)));

   case graphql_web.Kind.OBJECT:
    return jsutils_keyValMap.keyValMap(valueNode.fields, (field => field.name.value), (field => valueFromASTUntyped(field.value, variables)));

   case graphql_web.Kind.VARIABLE:
    return null == variables ? void 0 : variables[valueNode.name.value];
  }
};
