var language_predicates = require("../../language/predicates.js");

var graphql_web = require("@0no-co/graphql.web");

exports.ExecutableDefinitionsRule = function ExecutableDefinitionsRule(context) {
  return {
    Document(node) {
      for (const definition of node.definitions) {
        if (!language_predicates.isExecutableDefinitionNode(definition)) {
          context.reportError(new graphql_web.GraphQLError(`The ${definition.kind === graphql_web.Kind.SCHEMA_DEFINITION || definition.kind === graphql_web.Kind.SCHEMA_EXTENSION ? "schema" : '"' + definition.name.value + '"'} definition is not executable.`, {
            nodes: definition
          }));
        }
      }
      return !1;
    }
  };
};
