import { isExecutableDefinitionNode } from "../../language/predicates.mjs";

import { GraphQLError, Kind } from "@0no-co/graphql.web";

function ExecutableDefinitionsRule(context) {
  return {
    Document(node) {
      for (const definition of node.definitions) {
        if (!isExecutableDefinitionNode(definition)) {
          context.reportError(new GraphQLError(`The ${definition.kind === Kind.SCHEMA_DEFINITION || definition.kind === Kind.SCHEMA_EXTENSION ? "schema" : '"' + definition.name.value + '"'} definition is not executable.`, {
            nodes: definition
          }));
        }
      }
      return !1;
    }
  };
}

export { ExecutableDefinitionsRule };
