import { GraphQLError } from "@0no-co/graphql.web";

function KnownFragmentNamesRule(context) {
  return {
    FragmentSpread(node) {
      const fragmentName = node.name.value;
      if (!context.getFragment(fragmentName)) {
        context.reportError(new GraphQLError(`Unknown fragment "${fragmentName}".`, {
          nodes: node.name
        }));
      }
    }
  };
}

export { KnownFragmentNamesRule };
