var graphql_web = require("@0no-co/graphql.web");

exports.LoneAnonymousOperationRule = function LoneAnonymousOperationRule(context) {
  let operationCount = 0;
  return {
    Document(node) {
      operationCount = node.definitions.filter((definition => definition.kind === graphql_web.Kind.OPERATION_DEFINITION)).length;
    },
    OperationDefinition(node) {
      if (!node.name && operationCount > 1) {
        context.reportError(new graphql_web.GraphQLError("This anonymous operation must be the only defined operation.", {
          nodes: node
        }));
      }
    }
  };
};
