import { Kind, GraphQLError } from "@0no-co/graphql.web";

function LoneAnonymousOperationRule(context) {
  let operationCount = 0;
  return {
    Document(node) {
      operationCount = node.definitions.filter((definition => definition.kind === Kind.OPERATION_DEFINITION)).length;
    },
    OperationDefinition(node) {
      if (!node.name && operationCount > 1) {
        context.reportError(new GraphQLError("This anonymous operation must be the only defined operation.", {
          nodes: node
        }));
      }
    }
  };
}

export { LoneAnonymousOperationRule };
