var graphql_web = require("@0no-co/graphql.web");

exports.LoneSchemaDefinitionRule = function LoneSchemaDefinitionRule(context) {
  var _ref, _ref2, _oldSchema$astNode;
  const oldSchema = context.getSchema();
  const alreadyDefined = null !== (_ref = null !== (_ref2 = null !== (_oldSchema$astNode = null == oldSchema ? void 0 : oldSchema.astNode) && void 0 !== _oldSchema$astNode ? _oldSchema$astNode : null == oldSchema ? void 0 : oldSchema.getQueryType()) && void 0 !== _ref2 ? _ref2 : null == oldSchema ? void 0 : oldSchema.getMutationType()) && void 0 !== _ref ? _ref : null == oldSchema ? void 0 : oldSchema.getSubscriptionType();
  let schemaDefinitionsCount = 0;
  return {
    SchemaDefinition(node) {
      if (alreadyDefined) {
        context.reportError(new graphql_web.GraphQLError("Cannot define a new schema within a schema extension.", {
          nodes: node
        }));
        return;
      }
      if (schemaDefinitionsCount > 0) {
        context.reportError(new graphql_web.GraphQLError("Must provide only one schema definition.", {
          nodes: node
        }));
      }
      ++schemaDefinitionsCount;
    }
  };
};
