var jsutils_inspect = require("../../jsutils/inspect.js");

var type_definition = require("../../type/definition.js");

var graphql_web = require("@0no-co/graphql.web");

exports.ScalarLeafsRule = function ScalarLeafsRule(context) {
  return {
    Field(node) {
      const type = context.getType();
      const selectionSet = node.selectionSet;
      if (type) {
        if (type_definition.isLeafType(type_definition.getNamedType(type))) {
          if (selectionSet) {
            const fieldName = node.name.value;
            const typeStr = jsutils_inspect.inspect(type);
            context.reportError(new graphql_web.GraphQLError(`Field "${fieldName}" must not have a selection since type "${typeStr}" has no subfields.`, {
              nodes: selectionSet
            }));
          }
        } else if (!selectionSet) {
          const fieldName = node.name.value;
          const typeStr = jsutils_inspect.inspect(type);
          context.reportError(new graphql_web.GraphQLError(`Field "${fieldName}" of type "${typeStr}" must have a selection of subfields. Did you mean "${fieldName} { ... }"?`, {
            nodes: node
          }));
        }
      }
    }
  };
};
