var type_definition = require("../../type/definition.js");

var utilities_typeFromAST = require("../../utilities/typeFromAST.js");

var graphql_web = require("@0no-co/graphql.web");

exports.VariablesAreInputTypesRule = function VariablesAreInputTypesRule(context) {
  return {
    VariableDefinition(node) {
      const type = utilities_typeFromAST.typeFromAST(context.getSchema(), node.type);
      if (void 0 !== type && !type_definition.isInputType(type)) {
        const variableName = node.variable.name.value;
        const typeName = graphql_web.print(node.type);
        context.reportError(new graphql_web.GraphQLError(`Variable "$${variableName}" cannot be non-input type "${typeName}".`, {
          nodes: node.type
        }));
      }
    }
  };
};
